Index: /trunk/sources/HeuristicLab.Visualization.Test/HeuristicLab.Visualization.Test.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Visualization.Test/HeuristicLab.Visualization.Test.csproj	(revision 635)
+++ /trunk/sources/HeuristicLab.Visualization.Test/HeuristicLab.Visualization.Test.csproj	(revision 636)
@@ -4,5 +4,5 @@
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.30428</ProductVersion>
+    <ProductVersion>9.0.30729</ProductVersion>
     <SchemaVersion>2.0</SchemaVersion>
     <ProjectGuid>{23117533-8A91-474E-BBF6-C39485D0810A}</ProjectGuid>
@@ -39,4 +39,5 @@
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
     </Reference>
+    <Reference Include="System.Drawing" />
     <Reference Include="System.Windows.Forms" />
     <Reference Include="System.Xml.Linq">
@@ -52,4 +53,10 @@
     <Compile Include="HeuristicLabVisualizationTestApplication.cs" />
     <Compile Include="HeuristicLabVisualizationTestPlugin.cs" />
+    <Compile Include="MainForm.cs">
+      <SubType>Form</SubType>
+    </Compile>
+    <Compile Include="MainForm.designer.cs">
+      <DependentUpon>MainForm.cs</DependentUpon>
+    </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
@@ -68,4 +75,9 @@
     </ProjectReference>
   </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="MainForm.resx">
+      <DependentUpon>MainForm.cs</DependentUpon>
+    </EmbeddedResource>
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: /trunk/sources/HeuristicLab.Visualization.Test/HeuristicLabVisualizationTestApplication.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization.Test/HeuristicLabVisualizationTestApplication.cs	(revision 635)
+++ /trunk/sources/HeuristicLab.Visualization.Test/HeuristicLabVisualizationTestApplication.cs	(revision 636)
@@ -30,6 +30,6 @@
   class HeuristicLabVisualizationTestApplication : ApplicationBase {
     public override void Run() {
-//      Form mainForm = new MainForm();
-//      Application.Run(mainForm);
+      Form mainForm = new MainForm();
+      Application.Run(mainForm);
     }
   }
Index: /trunk/sources/HeuristicLab.Visualization.Test/MainForm.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization.Test/MainForm.Designer.cs	(revision 636)
+++ /trunk/sources/HeuristicLab.Visualization.Test/MainForm.Designer.cs	(revision 636)
@@ -0,0 +1,67 @@
+﻿namespace HeuristicLab.Visualization.Test {
+  partial class MainForm {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.canvasUI = new HeuristicLab.Visualization.CanvasUI();
+      this.label2 = new System.Windows.Forms.Label();
+      this.SuspendLayout();
+      // 
+      // canvasUI
+      // 
+      this.canvasUI.Location = new System.Drawing.Point(12, 29);
+      this.canvasUI.Name = "canvasUI";
+      this.canvasUI.Size = new System.Drawing.Size(800, 600);
+      this.canvasUI.TabIndex = 3;
+      this.canvasUI.Text = "canvasUI";
+      // 
+      // label2
+      // 
+      this.label2.AutoSize = true;
+      this.label2.Location = new System.Drawing.Point(9, 13);
+      this.label2.Name = "label2";
+      this.label2.Size = new System.Drawing.Size(43, 13);
+      this.label2.TabIndex = 4;
+      this.label2.Text = "Canvas";
+      // 
+      // Form1
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.ClientSize = new System.Drawing.Size(822, 637);
+      this.Controls.Add(this.label2);
+      this.Controls.Add(this.canvasUI);
+      this.Name = "Form1";
+      this.Text = "Form1";
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private HeuristicLab.Visualization.CanvasUI canvasUI;
+    private System.Windows.Forms.Label label2;
+  }
+}
+
Index: /trunk/sources/HeuristicLab.Visualization.Test/MainForm.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization.Test/MainForm.cs	(revision 636)
+++ /trunk/sources/HeuristicLab.Visualization.Test/MainForm.cs	(revision 636)
@@ -0,0 +1,84 @@
+﻿using System.Drawing;
+using System.Windows.Forms;
+using HeuristicLab.Visualization;
+
+namespace HeuristicLab.Visualization.Test {
+  public partial class MainForm : Form {
+    public MainForm() {
+      InitializeComponent();
+
+      canvasUI.MainCanvas.WorldShape = new WorldShape(new RectangleD(0, 0, 800, 600), new RectangleD(0, 0, 800, 600));
+
+      CreateLeftWorldShape();
+      CreateMiddleCompositeShape();
+      CreateRightWorldShape();
+      CreateSimpleRectangleShape();
+
+      canvasUI.Invalidate();
+    }
+
+    private void CreateSimpleRectangleShape() {
+      WorldShape mainWorld = canvasUI.MainCanvas.WorldShape;
+      // simple rectangle shape
+      RectangleShape rect7 = new RectangleShape(5, 5, 50, 50, 0, Color.Black);
+      mainWorld.AddShape(rect7);
+    }
+
+    private void CreateRightWorldShape() {
+      WorldShape mainWorld = canvasUI.MainCanvas.WorldShape;
+      // right world shape
+      WorldShape rightWorld = new WorldShape(new RectangleD(-1, -1, 1, 1), new RectangleD(600, 10, 780, 600));
+
+      double x1 = -3;
+      double y1 = -3;
+
+      for (int i = 0; i < 10000; i++) {
+        RectangleShape rect = new RectangleShape(x1, y1, x1+0.3, y1+0.3, 0, Color.Maroon);
+        x1 += 0.4; y1 += 0.4;
+        rightWorld.AddShape(rect);
+      }
+
+      mainWorld.AddShape(rightWorld);
+    }
+
+    private void CreateMiddleCompositeShape() {
+      WorldShape mainWorld = canvasUI.MainCanvas.WorldShape;
+      // middle composite shape
+      CompositeShape middleComp = new CompositeShape();
+
+      RectangleShape rect5 = new RectangleShape(400, 10, 500, 300, 0, Color.Navy);
+      RectangleShape rect6 = new RectangleShape(510, 310, 580, 590, 0, Color.Magenta);
+
+      middleComp.AddShape(rect5);
+      middleComp.AddShape(rect6);
+
+      mainWorld.AddShape(middleComp);
+    }
+
+    private void CreateLeftWorldShape() {
+      WorldShape mainWorld = canvasUI.MainCanvas.WorldShape;
+      // left world shape
+      WorldShape leftWorld = new WorldShape(new RectangleD(0, 0, 1000, 1000), new RectangleD(10, 10, 380, 590));
+
+      RectangleShape fillRect = new RectangleShape(0, 0, 1000, 1000, 0, Color.LightBlue);
+
+      RectangleShape rect1 = new RectangleShape(100, 100, 500, 500, 0, Color.Red);
+      RectangleShape rect2 = new RectangleShape(800, -200, 1200, 500, 0, Color.Green);
+
+      CompositeShape comp1 = new CompositeShape();
+
+      RectangleShape rect3 = new RectangleShape(510, 580, 590, 700, 0, Color.Blue);
+      RectangleShape rect4 = new RectangleShape(600, 710, 800, 900, 0, Color.Orange);
+
+      comp1.AddShape(rect3);
+      comp1.AddShape(rect4);
+
+      leftWorld.AddShape(fillRect);
+      leftWorld.AddShape(rect1);
+      leftWorld.AddShape(rect2);
+      leftWorld.AddShape(comp1);
+
+      mainWorld.AddShape(leftWorld);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Visualization.Test/MainForm.resx
===================================================================
--- /trunk/sources/HeuristicLab.Visualization.Test/MainForm.resx	(revision 636)
+++ /trunk/sources/HeuristicLab.Visualization.Test/MainForm.resx	(revision 636)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>