Index: branches/HL-3.2-MonoMigration/HeuristicLab.CEDMA.Server/ServerForm.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Server/ServerForm.cs	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.CEDMA.Server/ServerForm.cs	(revision 638)
@@ -46,5 +46,6 @@
     private Database database;
     private Store store;
-    private static readonly string dbFile = AppDomain.CurrentDomain.BaseDirectory + "/test.db3";
+    //private static readonly string dbFile = AppDomain.CurrentDomain.BaseDirectory + "/test.db3";
+    private static readonly string dbFile = AppDomain.CurrentDomain.BaseDirectory + "/debugging.db3";
     private static readonly string connectionString = "Data Source=\"" + dbFile + "\";Pooling=False";
     private static readonly string rdfFile = AppDomain.CurrentDomain.BaseDirectory + "rdf_store.db3";
@@ -86,5 +87,5 @@
       InitDatabase();
       InitRdfStore();
-      InitRunScheduler();
+      //InitRunScheduler();
 
       host = new ServiceHost(database, new Uri(addressTextBox.Text));
Index: branches/HL-3.2-MonoMigration/HeuristicLab.Core/OperatorLibraryEditor.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/OperatorLibraryEditor.cs	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.Core/OperatorLibraryEditor.cs	(revision 638)
@@ -162,5 +162,4 @@
     }
 
-
     #region TreeView Events
     private void operatorsTreeView_AfterSelect(object sender, TreeViewEventArgs e) {
@@ -238,5 +237,4 @@
     #endregion
 
-
     #region Mouse Events
     private void operatorsTreeView_MouseDown(object sender, MouseEventArgs e) {
@@ -249,5 +247,4 @@
     }
     #endregion
-
 
     #region Context Menu Events
Index: branches/HL-3.2-MonoMigration/HeuristicLab.Core/ScopeView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/ScopeView.Designer.cs	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.Core/ScopeView.Designer.cs	(revision 638)
@@ -32,9 +32,9 @@
     /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
     protected override void Dispose(bool disposing) {
-      if (scopesTreeView.Nodes.Count > 0) {
-        RemoveTreeNode(scopesTreeView.Nodes[0]);
-        scopesTreeView.Nodes.Clear();
-      }
-      if (disposing && (components != null)) {
+      //if(scopesTreeView.Nodes.Count > 0) {
+      //  RemoveTreeNode(scopesTreeView.Nodes[0]);
+      //  scopesTreeView.Nodes.Clear();
+      //}
+      if(disposing && (components != null)) {
         components.Dispose();
       }
Index: branches/HL-3.2-MonoMigration/HeuristicLab.Core/VariablesScopeView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/VariablesScopeView.cs	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.Core/VariablesScopeView.cs	(revision 638)
@@ -73,9 +73,11 @@
         variablesListView.Items.Clear();
         foreach (IVariable variable in Scope.Variables) {
-          ListViewItem item = new ListViewItem();
-          item.Text = variable.Name;
-          item.Tag = variable;
-          variablesListView.Items.Add(item);
-          variable.NameChanged += new EventHandler(Variable_NameChanged);
+          if (!variable.Name.StartsWith("##")) {
+            ListViewItem item = new ListViewItem();
+            item.Text = variable.Name;
+            item.Tag = variable;
+            variablesListView.Items.Add(item);
+            variable.NameChanged += new EventHandler(Variable_NameChanged);
+          }
         }
       }
@@ -157,9 +159,11 @@
         Invoke(new OnVariableEventDelegate(Scope_VariableAdded), sender, e);
       else {
-        ListViewItem item = new ListViewItem();
-        item.Text = e.Variable.Name;
-        item.Tag = e.Variable;
-        variablesListView.Items.Add(item);
-        e.Variable.NameChanged += new EventHandler(Variable_NameChanged);
+        if (!e.Variable.Name.StartsWith("##")) {
+          ListViewItem item = new ListViewItem();
+          item.Text = e.Variable.Name;
+          item.Tag = e.Variable;
+          variablesListView.Items.Add(item);
+          e.Variable.NameChanged += new EventHandler(Variable_NameChanged);
+        }
       }
     }
@@ -168,11 +172,13 @@
         Invoke(new OnVariableEventDelegate(Scope_VariableRemoved), sender, e);
       else {
-        ListViewItem itemToDelete = null;
-        foreach (ListViewItem item in variablesListView.Items) {
-          if (item.Tag == e.Variable)
-            itemToDelete = item;
-        }
-        e.Variable.NameChanged -= new EventHandler(Variable_NameChanged);
-        variablesListView.Items.Remove(itemToDelete);
+        if (!e.Variable.Name.StartsWith("##")) {
+          ListViewItem itemToDelete = null;
+          foreach (ListViewItem item in variablesListView.Items) {
+            if (item.Tag == e.Variable)
+              itemToDelete = item;
+          }
+          e.Variable.NameChanged -= new EventHandler(Variable_NameChanged);
+          variablesListView.Items.Remove(itemToDelete);
+        }
       }
     }
Index: branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/ApplicationInfo.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/ApplicationInfo.cs	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/ApplicationInfo.cs	(revision 638)
@@ -23,4 +23,5 @@
 using System.Collections.Generic;
 using System.Text;
+using System.Runtime.Serialization;
 
 namespace HeuristicLab.PluginInfrastructure {
@@ -69,4 +70,8 @@
       set { pluginType = value; }
     }
+
+    public override string ToString() {
+      return Name + " " + Version + " " + Description + " " + pluginAssembly + " " + pluginType;
+    }
   }
 }
Index: branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/BaseClasses/ApplicationBase.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/BaseClasses/ApplicationBase.cs	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/BaseClasses/ApplicationBase.cs	(revision 638)
@@ -34,4 +34,5 @@
     public ApplicationBase() {
       ReadAttributes();
+      Run();
     }
 
Index: branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/ClassInfoAttribute.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/ClassInfoAttribute.cs	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/ClassInfoAttribute.cs	(revision 638)
@@ -59,4 +59,8 @@
 
     public ClassInfoAttribute() {}
+
+    public ClassInfoAttribute(string name) {
+      Name = name;
+    }
   }
 }
Index: branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/DiscoveryService.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/DiscoveryService.cs	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/DiscoveryService.cs	(revision 638)
@@ -33,7 +33,12 @@
     public PluginInfo[] Plugins {
       get {
-        PluginInfo[] plugins = new PluginInfo[PluginManager.Manager.LoadedPlugins.Count];
-        PluginManager.Manager.LoadedPlugins.CopyTo(plugins, 0);
-        return plugins;
+        try {
+          PluginInfo[] plugins = new PluginInfo[PluginManager.Manager.LoadedPlugins.Count];
+          PluginManager.Manager.LoadedPlugins.CopyTo(plugins, 0);
+          return plugins;
+        } catch(Exception ex) {
+          Console.WriteLine(ex);
+          return new PluginInfo[] { };
+        }
       }
     }
Index: branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/InvalidPluginException.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/InvalidPluginException.cs	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/InvalidPluginException.cs	(revision 638)
@@ -23,7 +23,12 @@
 using System.Collections.Generic;
 using System.Text;
+using System.Runtime.Serialization;
 
 namespace HeuristicLab.PluginInfrastructure {
+  [Serializable]
   class InvalidPluginException : Exception {
+    public InvalidPluginException() : base() { }
+
+    public InvalidPluginException(SerializationInfo info, StreamingContext context) : base(info, context) { }
   }
 }
Index: branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/Loader.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Loader.cs	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/Loader.cs	(revision 638)
@@ -98,5 +98,5 @@
           return null;
         }
-        };
+      };
       allPlugins.Clear();
       disabledPlugins.Clear();
@@ -161,4 +161,13 @@
             }
           }
+        } catch(InvalidPluginException ex) {
+          PluginInfo info = new PluginInfo();
+          AssemblyName name = assembly.GetName();
+          info.Name = name.Name;
+          info.Version = name.Version;
+          info.Assemblies.Add(assembly.FullName);
+          info.Files.Add(assembly.Location);
+          info.Message = "Plugin doesn't have necessary meta-information: ";
+          disabledPlugins.Add(info);
         } catch(FileNotFoundException ex) {
           PluginInfo info = new PluginInfo();
@@ -198,28 +207,22 @@
       // iterate through all custom attributes and search for named arguments that we are interested in 
       foreach(CustomAttributeData attributeData in attributes) {
-        List<CustomAttributeNamedArgument> namedArguments = new List<CustomAttributeNamedArgument>(attributeData.NamedArguments);
-        // if the current attribute contains a named argument with the name "Name" then extract the plugin name
-        CustomAttributeNamedArgument pluginNameArgument = namedArguments.Find(delegate(CustomAttributeNamedArgument arg) {
-          return arg.MemberInfo.Name == "Name";
-        });
-        if(pluginNameArgument.MemberInfo != null) {
-          pluginName = (string)pluginNameArgument.TypedValue.Value;
-        }
-        // if the current attribute contains a named argument with the name "Dependency" then extract the dependency
-        // and store it in the list of all dependencies
-        CustomAttributeNamedArgument dependencyNameArgument = namedArguments.Find(delegate(CustomAttributeNamedArgument arg) {
-          return arg.MemberInfo.Name == "Dependency";
-        });
-        if(dependencyNameArgument.MemberInfo != null) {
-          pluginDependencies.Add((string)dependencyNameArgument.TypedValue.Value);
-        }
-        // if the current attribute has a named argument "Filename" then find if the argument "Filetype" is also supplied
-        // and if the filetype is Assembly then store the name of the assembly in the list of assemblies
-        CustomAttributeNamedArgument filenameArg = namedArguments.Find(delegate(CustomAttributeNamedArgument arg) {
-          return arg.MemberInfo.Name == "Filename";
-        });
-        CustomAttributeNamedArgument filetypeArg = namedArguments.Find(delegate(CustomAttributeNamedArgument arg) {
-          return arg.MemberInfo.Name == "Filetype";
-        });
+        CustomAttributeNamedArgument filenameArg;
+        CustomAttributeNamedArgument filetypeArg;
+        foreach(CustomAttributeNamedArgument arg in attributeData.NamedArguments) {
+          if(arg.MemberInfo.Name == "Name") {
+            // if the current attribute contains a named argument with the name "Name" then extract the plugin name
+            pluginName = (string)arg.TypedValue.Value;
+          } else if(arg.MemberInfo.Name == "Dependency") {
+            // if the current attribute contains a named argument with the name "Dependency" then extract the dependency
+            // and store it in the list of all dependencies
+            pluginDependencies.Add((string)arg.TypedValue.Value);
+          } else if(arg.MemberInfo.Name == "Filename") {
+            // if the current attribute has a named argument "Filename" then find if the argument "Filetype" is also supplied
+            // and if the filetype is Assembly then store the name of the assembly in the list of assemblies
+            filenameArg = arg;
+          } else if(arg.MemberInfo.Name == "Filetype") {
+            filetypeArg = arg;
+          }
+        }
         if(filenameArg.MemberInfo != null && filetypeArg.MemberInfo != null) {
           pluginFiles.Add(pluginDir + "/" + (string)filenameArg.TypedValue.Value);
@@ -229,5 +232,4 @@
         }
       }
-
       // minimal sanity check of the attribute values
       if(pluginName != "" && pluginAssemblies.Count > 0) {
@@ -393,5 +395,5 @@
     internal void OnDelete(PluginInfo pluginInfo) {
       IPlugin plugin = FindPlugin(pluginInfo);
-      if(plugin!=null) plugin.OnDelete();
+      if(plugin != null) plugin.OnDelete();
     }
 
Index: branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/PluginFileAttribute.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/PluginFileAttribute.cs	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/PluginFileAttribute.cs	(revision 638)
@@ -49,4 +49,8 @@
 
     public PluginFileAttribute() { }
+    public PluginFileAttribute(string name, PluginFileType type) {
+      this.Filename = name;
+      this.Filetype = type;
+    }
   }
 }
Index: branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/PluginManager.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/PluginManager.cs	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/PluginManager.cs	(revision 638)
@@ -27,12 +27,14 @@
   // must extend MarshalByRefObject because of event passing between Loader and PluginManager (each in it's own AppDomain)
   public class PluginManager : MarshalByRefObject {
-
     // singleton: only one manager allowed in each AppDomain
-    private static PluginManager manager = new PluginManager();
+    private static readonly PluginManager manager = PluginManager.manager==null?new PluginManager():PluginManager.manager;
+    static PluginManager() { Console.WriteLine("static ctor called "); }
     public static PluginManager Manager {
-      get { return manager; }
+      get {
+        return manager;
+      }
     }
 
-    // singleton: only one control manager allowed in each applicatoin (i.e. AppDomain)
+    // singleton: only one control manager allowed in each application (i.e. AppDomain)
     private static IControlManager controlManager;
     public static IControlManager ControlManager {
@@ -71,6 +73,16 @@
     private ICollection<PluginInfo> loadedPlugins;
     public ICollection<PluginInfo> LoadedPlugins {
-      get { return loadedPlugins; }
-      internal set { loadedPlugins = value; }
+      get {
+        Console.WriteLine(AppDomain.CurrentDomain.Id);
+        Console.WriteLine(this.GetHashCode());
+        if(loadedPlugins != null) Console.WriteLine(loadedPlugins.Count); else Console.WriteLine("Loaded plugins==null!");
+        return loadedPlugins;
+      }
+      internal set {
+        Console.WriteLine(AppDomain.CurrentDomain.Id);
+        Console.WriteLine(value.Count);
+        Console.WriteLine(this.GetHashCode());
+        loadedPlugins = new List<PluginInfo>(value);
+      }
     }
 
@@ -82,9 +94,14 @@
       AppDomainSetup setup = AppDomain.CurrentDomain.SetupInformation;
       setup.PrivateBinPath = pluginDir;
-      pluginDomain = AppDomain.CreateDomain("plugin domain", null, setup);
+      pluginDomain = AppDomain.CreateDomain("plugin domain");
+      pluginDomain.SetupInformation.PrivateBinPath = pluginDir;
       remoteLoader = (Loader)pluginDomain.CreateInstanceAndUnwrap("HeuristicLab.PluginInfraStructure", "HeuristicLab.PluginInfrastructure.Loader");
-      remoteLoader.PluginAction += delegate(object sender, PluginManagerActionEventArgs args) { if(Action != null) Action(this, args); };
+      remoteLoader.PluginAction += new PluginManagerActionEventHandler(remoteLoader_PluginAction);
       remoteLoader.Init();
       NotifyListeners(PluginManagerAction.Initialized, "-");
+    }
+
+    public void remoteLoader_PluginAction(object sender, PluginManagerActionEventArgs e) {
+      if(Action != null) Action(this, e);
     }
 
@@ -98,9 +115,10 @@
       // activate a PluginRunner instance in the application
       // and remotely tell it to start the application
-
+      Console.WriteLine(appInfo);
       NotifyListeners(PluginManagerAction.Starting, appInfo.Name);
       AppDomainSetup setup = AppDomain.CurrentDomain.SetupInformation;
       setup.PrivateBinPath = pluginDir;
-      AppDomain applicationDomain = AppDomain.CreateDomain(appInfo.Name + " AppDomain", null, setup);
+      AppDomain applicationDomain = AppDomain.CreateDomain(appInfo.Name + " AppDomain");
+      applicationDomain.SetupInformation.PrivateBinPath = pluginDir;
       try {
         Runner remoteRunner = (Runner)applicationDomain.CreateInstanceAndUnwrap("HeuristicLab.PluginInfrastructure", "HeuristicLab.PluginInfrastructure.Runner");
@@ -108,5 +126,5 @@
         remoteRunner.LoadPlugins(remoteLoader.ActivePlugins);
         NotifyListeners(PluginManagerAction.Initialized, "All plugins");
-        remoteRunner.Run(appInfo);
+        remoteRunner.Run(appInfo.PluginAssembly, appInfo.PluginType);
       } finally {
         // make sure domain is unloaded in all cases
Index: branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/Runner.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Runner.cs	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.PluginInfrastructure/Runner.cs	(revision 638)
@@ -24,4 +24,6 @@
 using System.Text;
 using System.Reflection;
+using System.Runtime.Remoting;
+using System.Runtime.Serialization;
 
 namespace HeuristicLab.PluginInfrastructure {
@@ -29,15 +31,21 @@
 
     public void LoadPlugins(ICollection<PluginInfo> plugins) {
+      List<string> loadedNames = new List<string>();
       foreach(PluginInfo pluginInfo in plugins) {
         foreach(string assemblyName in pluginInfo.Assemblies) {
-          Assembly.LoadFrom(assemblyName);
+          if(!loadedNames.Contains(assemblyName)) {
+            Console.WriteLine("Loading assembly " + assemblyName);
+            loadedNames.Add(assemblyName);
+            Assembly.LoadFrom(assemblyName);
+          }
         }
       }
+      Console.WriteLine(AppDomain.CurrentDomain.Id);
       PluginManager.Manager.LoadedPlugins = plugins;
     }
 
-    public void Run(ApplicationInfo appInfo) {
-      IApplication runnablePlugin = (IApplication)Activator.CreateInstance(appInfo.PluginAssembly, appInfo.PluginType).Unwrap();
-      runnablePlugin.Run();
+    public void Run(string assembly, string type) {
+      Console.WriteLine(AppDomain.CurrentDomain.Id);
+      object proxy = AppDomain.CurrentDomain.CreateInstanceAndUnwrap(assembly, type);
     }
 
Index: branches/HL-3.2-MonoMigration/HeuristicLab.Routing.TSP/HeuristicLab.Routing.TSP.csproj
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP/HeuristicLab.Routing.TSP.csproj	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.Routing.TSP/HeuristicLab.Routing.TSP.csproj	(revision 638)
@@ -3,5 +3,5 @@
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.30729</ProductVersion>
+    <ProductVersion>9.0.21022</ProductVersion>
     <SchemaVersion>2.0</SchemaVersion>
     <ProjectGuid>{9EF75B49-D507-44E0-BC5D-C200FDA53B9B}</ProjectGuid>
Index: branches/HL-3.2-MonoMigration/HeuristicLab.SGA/HeuristicLab.SGA.csproj
===================================================================
--- trunk/sources/HeuristicLab.SGA/HeuristicLab.SGA.csproj	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.SGA/HeuristicLab.SGA.csproj	(revision 638)
@@ -3,5 +3,5 @@
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.30729</ProductVersion>
+    <ProductVersion>9.0.21022</ProductVersion>
     <SchemaVersion>2.0</SchemaVersion>
     <ProjectGuid>{E39AF78A-9692-472B-B061-E2F1B1AB2C92}</ProjectGuid>
Index: branches/HL-3.2-MonoMigration/HeuristicLab.Scheduling.JSSP/HeuristicLab.Scheduling.JSSP.csproj
===================================================================
--- trunk/sources/HeuristicLab.Scheduling.JSSP/HeuristicLab.Scheduling.JSSP.csproj	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.Scheduling.JSSP/HeuristicLab.Scheduling.JSSP.csproj	(revision 638)
@@ -3,5 +3,5 @@
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.30729</ProductVersion>
+    <ProductVersion>9.0.21022</ProductVersion>
     <SchemaVersion>2.0</SchemaVersion>
     <ProjectGuid>{4C0EF782-CC94-4A94-BC3E-661D2600559B}</ProjectGuid>
Index: branches/HL-3.2-MonoMigration/HeuristicLab.SequentialEngine/HeuristicLab.SequentialEngine.csproj
===================================================================
--- trunk/sources/HeuristicLab.SequentialEngine/HeuristicLab.SequentialEngine.csproj	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.SequentialEngine/HeuristicLab.SequentialEngine.csproj	(revision 638)
@@ -3,5 +3,5 @@
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.30729</ProductVersion>
+    <ProductVersion>9.0.21022</ProductVersion>
     <SchemaVersion>2.0</SchemaVersion>
     <ProjectGuid>{B4BE8E53-BA06-4237-9A01-24255F880201}</ProjectGuid>
Index: branches/HL-3.2-MonoMigration/HeuristicLab.SimOpt/HeuristicLab.SimOpt.csproj
===================================================================
--- trunk/sources/HeuristicLab.SimOpt/HeuristicLab.SimOpt.csproj	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.SimOpt/HeuristicLab.SimOpt.csproj	(revision 638)
@@ -4,5 +4,5 @@
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.30729</ProductVersion>
+    <ProductVersion>9.0.21022</ProductVersion>
     <SchemaVersion>2.0</SchemaVersion>
     <ProjectGuid>{32DAA44F-944A-465F-A5C9-1C491EE4976D}</ProjectGuid>
Index: branches/HL-3.2-MonoMigration/HeuristicLab.TestFunctions/HeuristicLab.TestFunctions.csproj
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/HeuristicLab.TestFunctions.csproj	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.TestFunctions/HeuristicLab.TestFunctions.csproj	(revision 638)
@@ -4,5 +4,5 @@
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.30729</ProductVersion>
+    <ProductVersion>9.0.21022</ProductVersion>
     <SchemaVersion>2.0</SchemaVersion>
     <ProjectGuid>{9A781B2F-A58D-4270-A28A-3B14BBC11F4A}</ProjectGuid>
Index: branches/HL-3.2-MonoMigration/HeuristicLab.ThreadParallelEngine/HeuristicLab.ThreadParallelEngine.csproj
===================================================================
--- trunk/sources/HeuristicLab.ThreadParallelEngine/HeuristicLab.ThreadParallelEngine.csproj	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab.ThreadParallelEngine/HeuristicLab.ThreadParallelEngine.csproj	(revision 638)
@@ -3,5 +3,5 @@
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.30729</ProductVersion>
+    <ProductVersion>9.0.21022</ProductVersion>
     <SchemaVersion>2.0</SchemaVersion>
     <ProjectGuid>{6E757D0E-20F9-4E89-AF06-D7DA256870DB}</ProjectGuid>
Index: branches/HL-3.2-MonoMigration/HeuristicLab/CopyAssemblies.cmd
===================================================================
--- trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 637)
+++ branches/HL-3.2-MonoMigration/HeuristicLab/CopyAssemblies.cmd	(revision 638)
@@ -6,16 +6,16 @@
 mkdir plugins\temp
 mkdir plugins\backup
-copy %1\HeuristicLab.AdvancedOptimizationFrontend\%2\HeuristicLab.AdvancedOptimizationFrontend-3.2.dll .\plugins
-copy %1\HeuristicLab.AdvancedOptimizationFrontend\WeifenLuo.WinFormsUI.Docking.dll .\plugins
-copy %1\HeuristicLab.AdvancedOptimizationFrontend\"WeifenLuo.WinFormsUI.Docking License.txt" .\plugins
+REM copy %1\HeuristicLab.AdvancedOptimizationFrontend\%2\HeuristicLab.AdvancedOptimizationFrontend-3.2.dll .\plugins
+REM copy %1\HeuristicLab.AdvancedOptimizationFrontend\WeifenLuo.WinFormsUI.Docking.dll .\plugins
+REM copy %1\HeuristicLab.AdvancedOptimizationFrontend\"WeifenLuo.WinFormsUI.Docking License.txt" .\plugins
 copy %1\HeuristicLab.BitVector\%2\HeuristicLab.BitVector-3.2.dll .\plugins
-copy %1\HeuristicLab.CEDMA.Charting\%2\HeuristicLab.CEDMA.Charting-3.2.dll .\plugins
-copy %1\HeuristicLab.CEDMA.Core\%2\HeuristicLab.CEDMA.Core-3.2.dll .\plugins
-copy %1\HeuristicLab.CEDMA.DB\%2\HeuristicLab.CEDMA.DB-3.2.dll .\plugins
-copy %1\HeuristicLab.CEDMA.DB\%2\SemWeb.SqliteStore.dll .\plugins
-copy %1\HeuristicLab.CEDMA.DB\%2\SemWeb.dll .\plugins
-copy %1\HeuristicLab.CEDMA.DB.Interfaces\%2\HeuristicLab.CEDMA.DB.Interfaces-3.2.dll .\plugins
-copy %1\HeuristicLab.CEDMA.Operators\%2\HeuristicLab.CEDMA.Operators-3.2.dll .\plugins
-copy %1\HeuristicLab.CEDMA.Server\%2\HeuristicLab.CEDMA.Server-3.2.dll .\plugins
+REM copy %1\HeuristicLab.CEDMA.Charting\%2\HeuristicLab.CEDMA.Charting-3.2.dll .\plugins
+REM copy %1\HeuristicLab.CEDMA.Core\%2\HeuristicLab.CEDMA.Core-3.2.dll .\plugins
+REM copy %1\HeuristicLab.CEDMA.DB\%2\HeuristicLab.CEDMA.DB-3.2.dll .\plugins
+REM copy %1\HeuristicLab.CEDMA.DB\%2\SemWeb.SqliteStore.dll .\plugins
+REM copy %1\HeuristicLab.CEDMA.DB\%2\SemWeb.dll .\plugins
+REM copy %1\HeuristicLab.CEDMA.DB.Interfaces\%2\HeuristicLab.CEDMA.DB.Interfaces-3.2.dll .\plugins
+REM copy %1\HeuristicLab.CEDMA.Operators\%2\HeuristicLab.CEDMA.Operators-3.2.dll .\plugins
+REM copy %1\HeuristicLab.CEDMA.Server\%2\HeuristicLab.CEDMA.Server-3.2.dll .\plugins
 copy %1\HeuristicLab.Charting\%2\HeuristicLab.Charting-3.2.dll .\plugins
 copy %1\HeuristicLab.Charting.Data\%2\HeuristicLab.Charting.Data-3.2.dll .\plugins
@@ -26,12 +26,12 @@
 copy %1\HeuristicLab.Data\%2\HeuristicLab.Data-3.2.dll .\plugins
 copy %1\HeuristicLab.DataAnalysis\%2\HeuristicLab.DataAnalysis-3.2.dll .\plugins
-copy %1\HeuristicLab.DistributedEngine\%2\HeuristicLab.DistributedEngine-3.2.dll .\plugins
+REM copy %1\HeuristicLab.DistributedEngine\%2\HeuristicLab.DistributedEngine-3.2.dll .\plugins
 copy %1\HeuristicLab.Evolutionary\%2\HeuristicLab.Evolutionary-3.2.dll .\plugins
 copy %1\HeuristicLab.Functions\%2\HeuristicLab.Functions-3.2.dll .\plugins
-copy %1\HeuristicLab.Grid\%2\HeuristicLab.Grid-3.2.dll .\plugins
+REM copy %1\HeuristicLab.Grid\%2\HeuristicLab.Grid-3.2.dll .\plugins
 copy %1\HeuristicLab.Logging\%2\HeuristicLab.Logging-3.2.dll .\plugins
 copy %1\HeuristicLab.Operators\%2\HeuristicLab.Operators-3.2.dll .\plugins
 copy %1\HeuristicLab.Operators.Metaprogramming\%2\HeuristicLab.Operators.Metaprogramming-3.2.dll .\plugins
-copy %1\HeuristicLab.Operators.Programmable\%2\HeuristicLab.Operators.Programmable-3.2.dll .\plugins
+REM copy %1\HeuristicLab.Operators.Programmable\%2\HeuristicLab.Operators.Programmable-3.2.dll .\plugins
 copy %1\HeuristicLab.Operators.Stopwatch\%2\HeuristicLab.Operators.Stopwatch-3.2.dll .\plugins
 copy %1\HeuristicLab.OptimizationFrontend\%2\HeuristicLab.OptimizationFrontend-3.2.dll .\plugins
@@ -46,8 +46,8 @@
 copy %1\HeuristicLab.SGA\%2\HeuristicLab.SGA-3.2.dll .\plugins
 copy %1\HeuristicLab.SimOpt\%2\HeuristicLab.SimOpt-3.2.dll .\plugins
-copy %1\HeuristicLab.SQLite\%2\HeuristicLab.SQLite-3.2.dll .\plugins
-copy %1\HeuristicLab.SQLite\System.Data.SQLite.dll .\plugins
-copy %1\HeuristicLab.SQLite\"SQLite License.txt" .\plugins
-copy %1\HeuristicLab.SQLite\SQLite.NET.chm .\plugins
+REM copy %1\HeuristicLab.SQLite\%2\HeuristicLab.SQLite-3.2.dll .\plugins
+REM copy %1\HeuristicLab.SQLite\System.Data.SQLite.dll .\plugins
+REM copy %1\HeuristicLab.SQLite\"SQLite License.txt" .\plugins
+REM copy %1\HeuristicLab.SQLite\SQLite.NET.chm .\plugins
 copy %1\HeuristicLab.StructureIdentification\%2\HeuristicLab.StructureIdentification-3.2.dll .\plugins
 copy %1\HeuristicLab.TestFunctions\%2\HeuristicLab.TestFunctions-3.2.dll .\plugins