Index: branches/plugins/HeuristicLab.Functions/3.2/BakedFunctionTree.cs
===================================================================
--- branches/plugins/HeuristicLab.Functions/3.2/BakedFunctionTree.cs	(revision 649)
+++ branches/plugins/HeuristicLab.Functions/3.2/BakedFunctionTree.cs	(revision 652)
@@ -59,5 +59,4 @@
     private bool variablesExpanded = false;
     private List<IVariable> variables;
-    private BakedTreeEvaluator evaluator;
 
     public BakedFunctionTree() {
Index: branches/plugins/HeuristicLab.Functions/3.2/HeuristicLab.Functions.csproj
===================================================================
--- branches/plugins/HeuristicLab.Functions/3.2/HeuristicLab.Functions.csproj	(revision 649)
+++ branches/plugins/HeuristicLab.Functions/3.2/HeuristicLab.Functions.csproj	(revision 652)
@@ -3,5 +3,5 @@
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.30729</ProductVersion>
+    <ProductVersion>9.0.21022</ProductVersion>
     <SchemaVersion>2.0</SchemaVersion>
     <ProjectGuid>{B95CA6E2-34BC-4430-994D-BD6E99375319}</ProjectGuid>
@@ -59,4 +59,32 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HeuristicLab.Constraints-3.2, Version=3.2.0.582, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>C:\Program Files\HeuristicLab 3.0\plugins\HeuristicLab.Constraints-3.2.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Core-3.2, Version=3.2.0.643, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>C:\Program Files\HeuristicLab 3.0\plugins\HeuristicLab.Core-3.2.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Data-3.2, Version=3.2.0.582, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>C:\Program Files\HeuristicLab 3.0\plugins\HeuristicLab.Data-3.2.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.DataAnalysis-3.2, Version=3.2.0.620, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>C:\Program Files\HeuristicLab 3.0\plugins\HeuristicLab.DataAnalysis-3.2.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Operators-3.2, Version=3.2.0.591, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>C:\Program Files\HeuristicLab 3.0\plugins\HeuristicLab.Operators-3.2.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.PluginInfrastructure, Version=3.2.0.581, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>C:\Program Files\HeuristicLab 3.0\HeuristicLab.PluginInfrastructure.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Random-3.2, Version=3.2.0.582, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>C:\Program Files\HeuristicLab 3.0\plugins\HeuristicLab.Random-3.2.dll</HintPath>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core">
@@ -119,38 +147,4 @@
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\HeuristicLab.Constraints\HeuristicLab.Constraints.csproj">
-      <Project>{FCD62C6F-4793-4593-AE9A-0BDCA256EE99}</Project>
-      <Name>HeuristicLab.Constraints</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\HeuristicLab.Core\HeuristicLab.Core.csproj">
-      <Project>{F43B59AB-2B8C-4570-BC1E-15592086517C}</Project>
-      <Name>HeuristicLab.Core</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\HeuristicLab.DataAnalysis\HeuristicLab.DataAnalysis.csproj">
-      <Project>{7DD3A97A-56E9-462F-90E2-A351FE7AF5C2}</Project>
-      <Name>HeuristicLab.DataAnalysis</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\HeuristicLab.Data\HeuristicLab.Data.csproj">
-      <Project>{F473D9AF-3F09-4296-9F28-3C65118DAFFA}</Project>
-      <Name>HeuristicLab.Data</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\HeuristicLab.Operators.Programmable\HeuristicLab.Operators.Programmable.csproj">
-      <Project>{E3CCBFC6-900C-41B6-AFB8-6646DB097435}</Project>
-      <Name>HeuristicLab.Operators.Programmable</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\HeuristicLab.Operators\HeuristicLab.Operators.csproj">
-      <Project>{A9983BA2-B3B2-475E-8E2C-62050B71D1C5}</Project>
-      <Name>HeuristicLab.Operators</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
-      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
-      <Name>HeuristicLab.PluginInfrastructure</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\HeuristicLab.Random\HeuristicLab.Random.csproj">
-      <Project>{47019A74-F7F7-482E-83AA-D3F4F777E879}</Project>
-      <Name>HeuristicLab.Random</Name>
-    </ProjectReference>
-  </ItemGroup>
-  <ItemGroup>
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.frame" />